<script>
import ChevronLg from '~/static/nuxt-images/ico/chevron-lg.vue';

export default {
  components: {
    ChevronLg,
  },
  props: {
    data: {
      required: true,
      type: Object,
    },
    isOpen: {
      required: true,
      type: Boolean,
    },
  },
  computed: {
    control() {
      if (this.isOpen === false) {
        return '<svg width="24" height="33" viewBox="0 0 24 33" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M12.75 8.85596C12.75 8.44174 12.4142 8.10596 12 8.10596C11.5858 8.10596 11.25 8.44174 11.25 8.85596V15.981H4.125C3.71079 15.981 3.375 16.3167 3.375 16.731C3.375 17.1452 3.71079 17.481 4.125 17.481H11.25V24.606C11.25 25.0202 11.5858 25.356 12 25.356C12.4142 25.356 12.75 25.0202 12.75 24.606V17.481H19.875C20.2892 17.481 20.625 17.1452 20.625 16.731C20.625 16.3167 20.2892 15.981 19.875 15.981H12.75V8.85596Z" fill="#171321"/></svg>';
      }
      return '<svg width="24" height="33" viewBox="0 0 24 33" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M3.375 16.731C3.375 16.3167 3.71079 15.981 4.125 15.981L19.875 15.981C20.2892 15.981 20.625 16.3167 20.625 16.731C20.625 17.1452 20.2892 17.481 19.875 17.481L4.125 17.481C3.71079 17.481 3.375 17.1452 3.375 16.731Z" fill="#171321"/></svg>';
    },
  },
  methods: {
    toggleAccordion() {
      this.$emit('toggleController');
    },
  },
};
</script>

<template>
  <div
    class="accordion"
    data-inbound-analytics="why-gitlab-leap-target"
    :data-toggle-group="data.header"
    :data-ga-toggle="isOpen ? 'collapse' : 'expand'"
  >
    <div
      class="summary"
      role="button"
      :aria-label="isOpen ? '' : 'expand section ' + data.header"
      :tabindex="isOpen ? -1 : 0"
      @click="toggleAccordion"
    >
      <SlpTypography tag="h4" variant="heading5">
        {{ data.header }}
      </SlpTypography>
      <span v-html="control"></span>
    </div>
    <div v-show="isOpen" class="content-container">
      <div class="content" v-html="$md.render(data.text)"></div>
      <a
        v-if="data.link_url"
        :href="data.link_url"
        :data-ga-name="data.data_ga_name"
        :data-ga-location="data.data_ga_location"
        >Learn more <ChevronLg fill="#7759C2" direction="right"
      /></a>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.accordion {
  color: $color-text-300;
  list-style-type: none;
  overflow: hidden;
  width: 100%;
  text-align: left;

  &:first-of-type {
    border-radius: 3px 3px 0 0;
    border-top-width: 1px;
  }

  .summary {
    cursor: pointer;
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding: $spacing-8 0;
    border-top: 1px solid $color-surface-300;
  }

  h4 {
    display: flex;
    align-items: center;
    font-weight: $font-weight-bold;
  }

  span {
    border: none;
    cursor: pointer;
    padding: $spacing-8;
  }

  .content-container {
    text-align: left;
    padding: 0 0 $spacing-24 0;
    font-size: $text-body-1;
    line-height: $line-height-default;

    a {
      display: flex;
      align-items: center;
      font-weight: $font-weight-bold;

      svg {
        margin-left: 4px;
      }
    }
  }

  .content {
    margin-top: $spacing-16;
    margin-bottom: $spacing-24;
  }

  .content ::v-deep {
    p,
    li,
    a {
      font-size: $font-size-default;
      line-height: $line-height-default;
      margin-bottom: $spacing-8;
    }

    ul {
      list-style: url('~static/nuxt-images/icons/slp-checkmark.svg');
      padding-left: $spacing-24;
    }

    li {
      padding-left: $spacing-8;
    }
  }
}
</style>
